{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clequipoprofe;
interface
uses  IniFiles,unix,ExtCtrls,SysUtils,clcomandosroot;
type

   { Tequipo }

  { TEquipoProfe }

  TEquipoProfe= class
  private
    { Private declarations }
    fhost,fip,fmac:string;
    fpuerto:integer;
    farccontravnc:string;
    fRatonTecladosInactivos:Boolean;
    fAccesoInternetInactivo:Boolean;
    fEspecialidaProfe,fnombreProfe:string;
    fNombreAplicacion:array [0..8] of string;
    fComandoAplicacion:array [0..8] of string;
    fasignaprofe: array [0..7] of string;
    farccursos:string;
    fUsuarioProfesor, fHomeProfesor, fdirAulalinex, fdirRecibidos:string;
    fArcExamenCorregido,fdirCuestiones,farcCuestion,farcexamen,fdirCapturas,farcCaptura:string;
    fdirexamenes,fdirexacorregidos,farcsetupprofe,farcmensaje,farcfavoritosweb:string;
    fcontravncprofe:string;
    fcontravncalumno:string;
    procedure CargarPathDirectorios();
    procedure EjecutarComandosRoot (codigo : integer ; comando : string);
    function HallarDatos(Cmd: string): String;
    function HallarDatosUsuario(const S: string): string;
    function hallarHostProfe(): string;
    procedure hallarIP();
    function hallarMAC(): string;

  public
       constructor Create();
       property Host:string read fhost write fhost;
       property IP:string read fIP;
       property Puerto:integer read fPuerto;
       property UsuarioProfesor:string read fUsuarioProfesor;
       property HomeProfesor:string read fHomeProfesor;
       property DirAulalinex:string read fdirAulalinex;
       property DirCuestiones:string read fdirCuestiones;
       property DirExamenes:string read fdirexamenes;
       property DirExaCorregidos:string read fdirexacorregidos;
       property ArcExamenCorregido:string read fArcExamenCorregido write fArcExamenCorregido;
       property ArcCuestion:string read farcCuestion write farcCuestion;
       property ArcExamen:string read farcexamen write farcexamen;
       property DirRecibidos:string read fdirrecibidos;
       property DirCapturas:string read fdirCapturas;
       property ArcCaptura:string read farcCaptura;
       property ArcSetupProfe:string read farcsetupprofe;
       property ArcMensaje:string read farcmensaje;
       property ArcCursos:string read farccursos;
       property ContraVNCProfe:string read fcontravncprofe write fcontravncprofe;
       property ContraVNCAlumno:string read fcontravncalumno write fcontravncalumno;
       property ArcContraVNC:string read farccontravnc write farccontravnc;
       property ArcFavoritosWeb:string read farcfavoritosweb;
       property RatonTecladosInactivos:Boolean read fRatonTecladosInactivos write fRatonTecladosInactivos;
       property AccesoInternetInactivo:Boolean read fAccesoInternetInactivo write fAccesoInternetInactivo;
       procedure apagarProfesor ();
       procedure desactivarInternet (elusuario:string);
       procedure activarInternet (elusuario:string);
       procedure LeerSetupProfe();

  end;


implementation
uses globales;
constructor TEquipoProfe.Create();
    begin
        fpuerto:=36999;
        fhost:=hallarHostProfe;
        fip:='localhost';
        fmac:=hallarMAC();
        fRatonTecladosInactivos:=false;
        fAccesoInternetInactivo:=false;
        fUsuarioProfesor:=HallarDatosUsuario('USER');
        fHomeProfesor:=HallarDatosUsuario('HOME');
        CargarPathDirectorios();
        fcontravncalumno:='02101067';
        fcontravncprofe:=inttostr(random(999999));
    end;

procedure TEquipoProfe.CargarPathDirectorios();
    begin

        fdirAulalinex:=fHomeProfesor+PathDelim+'.aulalinex';
        fdirRecibidos:=fHomeProfesor+PathDelim+'recibidos';
        fdirCuestiones:=fHomeProfesor+PathDelim+'aulalinex_consultas';
        fdirexamenes:=fdirCuestiones+PathDelim+'examenes';
        fdirexacorregidos:=fdirexamenes+PathDelim+'corregidos';
        fdirCapturas:=fdirAulalinex+PathDelim+'aulalinex_capturas';
        farcCaptura:=fdirAulalinex+PathDelim+'captura.png';
        farcsetupprofe:=fdirAulalinex +PathDelim+'setupprofe.ini';
        farcmensaje:=fdirAulalinex +PathDelim+'mensaje.ini';
        farcfavoritosweb:=fdirAulalinex +PathDelim+'favoritos.ini';
        farccursos:=fdirAulalinex+PathDelim+'.cursos.ini';;
        farccontravnc:=fdirAulalinex +PathDelim+'aulapas674545';
    end;

Function TEquipoProfe.HallarDatosUsuario(const S :string):string;
    begin
        result:=getenvironmentvariable(S);
    end;
Procedure TEquipoProfe.LeerSetupProfe();
    var
        MiFichero:TMeminiFile;
        i:integer;
    begin
        Mifichero:=TMeminifile.Create(farcsetupprofe);
        with MIfichero do
            begin
                fnombreProfe:=ReadString('Profesor','Nombre','');
                fEspecialidaProfe:=ReadString('Profesor','Especialidad','Mi especialidad');
                for i:=0 to 8 do
                    begin
                        fNombreAplicacion[i]:=ReadString ('Programas','Programa_'+inttostr(i),'');
                        fComandoAplicacion[i]:=ReadString ('Comandos','Comando_'+inttostr(i),'');
                    end;
                for i:= 0 to 7 do
                    fasignaprofe[i]:=ReadString('Asignaturas','Asignatura_'+inttostr(i),'1ESO_ASI0'+inttostr(i+1));
                free;
            end;
    end;

function TEquipoProfe.HallarDatos(Cmd:string):String;
    var
        file1: TextFile;
        s,t: ansistring;
        n: longint;
        j:integer;
    begin
        j:=0;
        n:=popen(file1, Cmd, 'r');
        if n=-1 then
            begin
                result:='';
                Mensaje('Error al hallar dato',Aceptar);
                Exit;
            end;
        t:='';
        while not eof(file1) do begin
            Readln(File1,s);
            t:=t+s+Chr(10);
            inc(j);
        end;
        pclose(file1);
        result := trim(t);
    end;

procedure TEquipoProfe.hallarIP();
    const
       orden:string='/sbin/ifconfig | grep Ethernet |head -1 | tr -s " " | cut -f5 -d" "';
    begin
        orden:='desactivarInternet';
        EjecutarComandosRoot(303,orden);
    end;

function TEquipoProfe.hallarHostProfe():string;
    const
        ORDEN_HOST:string='hostname | cut -f1 -d"."';
    begin
        result:=HallarDatos(ORDEN_HOST);
    end;

function TEquipoProfe.hallarMAC():string;
    const
       ORDEN_MAC:string='/sbin/ifconfig | grep Ethernet |head -1 | tr -s " " | cut -f5 -d" "';

    begin
        result:=HallarDatos(ORDEN_MAC);

    end;

procedure TEquipoProfe.desactivarInternet (elusuario:string);
    var
       orden:string;
    begin
        orden:='desactivarInternet '+ elusuario;
        EjecutarComandosRoot(303,orden);
    end;

procedure TEquipoProfe.activarInternet (elusuario:string);
    var
       orden:string;
    begin
        orden:='activarInternet '+ elusuario;
        EjecutarComandosRoot(304,orden);
    end;

procedure TEquipoProfe.apagarProfesor ();
    begin
        EjecutarComandosRoot(302,'apagarEquipo');
    end;

procedure  TEquipoProfe.EjecutarComandosRoot(codigo:integer;comando:string);
    begin;
         with ThrComandosRoot.create(codigo,fIP,comando) do Resume;
    end;

end.

