{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clping;

interface

uses
  globales,SysUtils,Classes, IdComponent, IdTCPClient;

type
  ThrPing = class(TThread)
  private
    { Private declarations }
      fEstadoActividad:TEstadoActividadEquipo;
      fconectado:Boolean;
      fpuerto,fnumero:integer;
      fhost:string;
      fcliente: TIdTCPClient;
      fusuario:string;
      procedure refrescarConectados;
 protected
    procedure Execute; override;
 public
       constructor Create(puerto:integer;numero:integer;host:string;EstadoActividad:TEstadoActividadEquipo);
  end;


implementation
uses inicio;
constructor ThrPing.Create(puerto:integer;numero:integer;host:string;EstadoActividad:TEstadoActividadEquipo);
    begin
        inherited Create(true);
        FreeOnTerminate:=True;
        Priority:=tpTimeCritical;
        fnumero:=numero;
        fEstadoActividad:=EstadoActividad;
        fpuerto:=puerto;
        fhost:=host;
    end;

procedure ThrPing.Execute;
    begin
        try
            fcliente:=TIdTCPClient.create(nil);
            fcliente.Host:=fhost;
            fcliente.port:=PUERTO_ROOT;
            fconectado:=false;
            fconectado:=false;
            fusuario:='';
            try
                fcliente.connect;
                fcliente.GetResponse(200);
                fcliente.Disconnect();
                fconectado:=true;
            except
                fcliente.Disconnect();
                fusuario:='';
                fconectado:=false;
            end;
            try
               if fconectado then
                  begin
                       fcliente.Host:='localhost';
                       fcliente.port:=fpuerto;
                       fcliente.connect;
                       fcliente.GetResponse(200);
                       fcliente.SendCmd('hallarUsuario',306);
                       fusuario:= trim(fcliente.LastCmdResult.text.text);
                  end;
             except
                fcliente.Disconnect();
                fusuario:='';
             end;

        finally
            fcliente.Disconnect;
            fcliente.free;
            synchronize(@refrescarConectados)
        end;
    end;

procedure  ThrPing.refrescarConectados;
    var
       ActEst:TEstadoActividadEquipo;
    begin
         case fEstadoActividad of
            eAveriado: ActEst:=eAveriado;
            eApagando:
                begin
                    if not fconectado then
                       ActEst:=eApagado
                    else
                       ActEst:=eApagando;

                end;
            eEncendiendo:
                begin
                    if fconectado then
                       ActEst:=eEncendido
                    else
                       ActEst:=eEncendiendo;
                end;
            else
                begin
                   if not fconectado then
                      ActEst:=eApagado
                   else if fconectado and (fusuario<>'') then
                      ActEst:=eUsuario
                   else if fconectado and (fusuario='') then
                      ActEst:=eEncendido
                   else
                      ActEst:=eApagado
                end;
         end;
        frmMain.RefrescarEquipoAula(fnumero,fusuario,ActEst);
    end;

end.
