{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit colocar; 

{$mode objfpc}{$H+}

interface

uses
  globales,textomensajes,configurarpro, Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type
   DistribucioEquipos=record
        posI:Tpoint;
        posF:Tpoint;
        mostrado:boolean;
   end;
type

  { TfrmColocar }
  TfrmColocar = class(TForm)
    btnLimpiar: TButton;
    btnSalir: TButton;
    cboNumOrd: TComboBox;
    cboNumCol: TComboBox;
    cboNumFil: TComboBox;
    imlFondo: TImageList;
    imgFondo: TImage;
    imlActivo: TImageList;
    imlInactivo: TImageList;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label88: TLabel;
    procedure btnLimpiarClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure cboNumColChange(Sender: TObject);
    procedure cboNumFilChange(Sender: TObject);
    procedure cboNumOrdChange(Sender: TObject);
    procedure cboNumOrdKeyPress(Sender: TObject; var Key: char);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure imgFondoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    procedure ColocarEquipos;
    procedure CrearOrdenadores();
    procedure GuardarPosiciones;
    procedure LimpiarMonitores;
    procedure OrdenataClick(Sender: TObject);
    procedure OrdenataDblClick(Sender: TObject);
    procedure PintarLineas(numfilas, numcol: integer);
    function ValidarDatos: boolean;
    { private declarations }
  public
    { public declarations }
  end; 

Const
    TOP_MINIMO:integer=50;
    TOP_MAXIMO:integer=533;
    LEFT_MINIMO:integer=440;
    LEFT_MAXIMO:integer=801;
    W_ORDENADOR:integer=66;
    H_ORDENADOR:integer=61;
    W_ETIQUETA:integer=113;
    H_ETIQUETA:integer=15;
    L_ETIQUETA:integer=22;
    T_ETIQUETA:integer=61;
    W_ORD_CHICO:integer=32;
    H_ORD_CHICO:integer=32;
    L_ORD_CHICO:integer=6;
    T_ORD_CHICO:integer=575;
    W_CUADRO:integer=451;
    H_CUADRO:integer=545;
var
  frmColocar: TfrmColocar;
  Ordenata:Array[0..23]of TImage;
  OrdenataChico:Array[0..23] of TImage;
  lblOrdenata:Array[0..23] of Tlabel;
  Posiciones:Array[0..23] of DistribucioEquipos;

implementation
var
   f_EquipoActivo:integer=-1;

Function TfrmColocar.ValidarDatos:boolean;
    var
        TextoMensaje:string;
        i:integer;
    begin
        if length(cboNumOrd.text)<1 then
            TextoMensaje:=MEN_INDICA_NUM_ORD
        else
            TextoMensaje:='';
        for i:=0 to strtoint(cboNumOrd.Text)-1 do
            if not Posiciones[i].mostrado  then
                TextoMensaje:=MEN_COLOCAR_EQUIPOS;
        result:=TextoMensaje='';
        if not result then
                mensaje(TextoMensaje,aceptar);
    end;

procedure TfrmColocar.PintarLineas(numfilas,numcol:integer);
    var
        disth,distv,l,j,t:integer;
        li,lf,ti,tf:integer;
    begin
        with imgFondo.canvas do
            begin
                Font.Style:=[fsbold];
                Pen.Width:=2;
                Pen.Color:=clsilver;
                disth:=(W_CUADRO-(numcol*W_ETIQUETA))div(numcol+1);
                li:=LEFT_MINIMO+disth+22;
                lf:=LEFT_MINIMO+((numcol)*disth)+((numcol-1)*W_ETIQUETA)+22;
                distv:=(H_CUADRO-(numfilas*(H_ETIQUETA+H_ORDENADOR))) div(numfilas+1);;
                ti:=TOP_MINIMO+distv;
                tf:=TOP_MINIMO+(numfilas*distv)+((numfilas-1)*(H_ETIQUETA+H_ORDENADOR));
                for j:=0 to numcol-1 do
                    begin
                        l:=LEFT_MINIMO+((j+1)*disth)+(j*W_ETIQUETA);
                        l:=l+L_ETIQUETA;
                        TextOut(l,ti-20,(inttostr(numcol)+'.'+inttostr(j+1)));
                        MoveTo(l,ti );
                        lineto(l,tf);
                    end;
                for j:=0 to numfilas-1 do
                    begin
                        t:=TOP_MINIMO+((j+1)*distv)+(j*(H_ETIQUETA+H_ORDENADOR));
                        TextOut(li-22,t-8,(inttostr(numfilas)+'.'+inttostr(j+1)));
                        MoveTo(li,t );
                        lineto(lf,t);
                    end;
            end;
    end;

procedure TfrmColocar.OrdenataDblClick(Sender: TObject);
    var
        numequ:integer;
    begin
        f_EquipoActivo:=-1;
        numequ:=(sender as Timage).tag;
        with Posiciones[numequ] do
            begin
                posF.x:=-1;
                posF.y:=-1;
                mostrado:=false;
                (sender as Timage).SetBounds(posI.x,posi.y,W_ORD_CHICO,H_ORD_CHICO);
            end;
        lblordenata[numequ].SetBounds(Ordenata[numequ].Left-L_ETIQUETA,Ordenata[numequ].top+T_ETIQUETA,W_ETIQUETA,H_ETIQUETA);
        lblordenata[numequ].Visible:=false;
        imlActivo.GetBitmap((sender as Timage).Tag,(sender as Timage).Picture.Bitmap);
    end;

procedure TfrmColocar.OrdenataClick(Sender: TObject);
    begin
        f_EquipoActivo:=(sender as Timage).Tag;
        LimpiarMonitores;
        imlInactivo.GetBitmap(f_EquipoActivo,(sender as Timage).Picture.Bitmap);
    end;

procedure TfrmColocar.LimpiarMonitores;
    var
        i:integer;
    begin
        for i:= 0 to 23 do
            begin
                with Ordenata[i] do
                    begin
                        Cursor:=crhandpoint;
                        imlActivo.GetBitmap(i,Picture.Bitmap);
                    end;
            end;
    end;

procedure TfrmColocar.GuardarPosiciones;
    var
        i:integer;
    begin
        g_DisenoClase:=1;
        g_num_diseno:=strtoint(cbonumord.text);
        for i:=0 to g_num_diseno-1 do
            begin
                f_Posiciones[i].x:=Posiciones[i].posF.x;
                f_Posiciones[i].y:=Posiciones[i].posF.Y;
            end;
        frmConPro.MostrarPersonal;
    end;

procedure TfrmColocar.btnLimpiarClick(Sender: TObject);
    var
        i:integer;
    begin
        if mensaje(MEN_RETIRAR_MONITORES,sino)=2 then exit;
        for i:=0 to high(Ordenata) do
            begin
                with Posiciones[i] do
                    begin
                        posF.x:=-1;
                        posF.Y:=-1;
                        mostrado:=false;
                        Ordenata[i].SetBounds(posi.x,posi.y,W_ORD_CHICO,W_ORD_CHICO);
                    end;
                lblordenata[i].Visible:=false;
            end;
    end;

procedure TfrmColocar.btnSalirClick(Sender: TObject);
    begin
        close;
    end;

procedure TfrmColocar.cboNumColChange(Sender: TObject);
    begin
         imlFondo.GetBitmap(0,imgFondo.Picture.Bitmap);
         cboNumFil.ItemIndex:=-1;
    end;

procedure TfrmColocar.cboNumFilChange(Sender: TObject);
    begin
         if (cboNumcol.ItemIndex <>-1) and (cboNumCol.ItemIndex<>-1) then
         imlFondo.GetBitmap(0,imgFondo.Picture.Bitmap);
        PintarLineas(StrToInt(cboNumfil.text),strtoint(cboNumCol.text))
    end;


procedure TfrmColocar.cboNumOrdChange(Sender: TObject);
    var
        i:integer;
    begin
        for i:=0 to 23 do
            begin
                Ordenata[i].Visible:=false;
                lblOrdenata[i].Visible:=false;
            end;
        for i:=0 to cboNumOrd.ItemIndex do
            begin
                Ordenata[i].Visible:=true;
                if Posiciones[i].posF.x<>-1 then lblOrdenata[i].Visible:=true;
            end;
        f_EquipoActivo:=-1
    end;


procedure TfrmColocar.cboNumOrdKeyPress(Sender: TObject; var Key: char);
    begin
        Key:=#0
    end;

procedure TfrmColocar.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        CloseAction:=cafree;
    end;

procedure TfrmColocar.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        if mensaje(MEN_SALIR_ZONA,sino)=1 then
            begin
                if mensaje(MEN_GUARDAR,sino)=1 then
                    begin
                        if validardatos then
                            begin
                                GuardarPosiciones;
                            end
                        else
                            Canclose:=false;
                    end
            end
        else
            canclose:=false;
    end;

procedure TfrmColocar.FormCreate(Sender: TObject);
    var
        i:integer;
    begin

         top:=13;left:=(screen.Width-width)div 2;
         for i:=0 to 23 do
             cboNumOrd.Items.Add(inttostr(i+1));
         cboNumOrd.Text:=inttostr(g_num_ord_aula);
         imlFondo.GetBitmap(0,imgFondo.Picture.Bitmap);
         CrearOrdenadores;
         ColocarEquipos;
         Application.ProcessMessages;
    end;

procedure TfrmColocar.imgFondoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    begin
        if (f_EquipoActivo=-1) or (f_EquipoActivo>=(strtoint(cboNumOrd.Text))) then exit;
        if ((x<LEFT_MINIMO) or (x>LEFT_MAXIMO)or(y<TOP_MINIMO) or (Y>TOP_MAXIMO)) then exit;
        with Posiciones[f_EquipoActivo] do
           begin
               posF.x:=X;
               posF.y:=y;
               mostrado:=true;
           end;
        with  Ordenata[f_EquipoActivo] do
           begin
               BringToFront;
               SetBounds(x,y,W_ORDENADOR,H_ORDENADOR);
           end;
        with lblordenata[f_EquipoActivo] do
           begin
               BringToFront;
               SetBounds(Ordenata[f_EquipoActivo].Left-L_ETIQUETA,Ordenata[f_EquipoActivo].top+T_ETIQUETA,W_ETIQUETA,H_ETIQUETA);
               Visible:=true;
           end;
    end;

procedure TfrmColocar.ColocarEquipos;
    var
        i:integer;
    begin
        if g_DisenoClase<1 then exit;
        for i:=0 to g_num_diseno-1 do
            begin
                if  (f_Posiciones[i].x>400) and (f_Posiciones[i].y>30) then
                    begin
                        Posiciones[i].posF.x:=f_Posiciones[i].x;
                        Posiciones[i].posF.Y:=f_Posiciones[i].Y;
                        Posiciones[i].mostrado:=true;
                        Ordenata[i].BringToFront;
                        lblordenata[i].BringToFront;
                        Ordenata[i].SetBounds(f_Posiciones[i].x,f_Posiciones[i].Y,W_ORDENADOR,H_ORDENADOR);
                        lblordenata[i].SetBounds(Ordenata[i].Left-L_ETIQUETA,Ordenata[i].top+T_ETIQUETA,W_ETIQUETA,H_ETIQUETA);
                        lblordenata[i].Visible:=true;
                    end
                else
                    begin
                        Posiciones[i].posF.x:=-1;
                        Posiciones[i].posF.Y:=-1;
                        Posiciones[i].mostrado:=false;
                        Ordenata[i].SetBounds(Posiciones[i].posi.x,Posiciones[i].posi.y,W_ORD_CHICO,W_ORD_CHICO);
                        lblordenata[i].Visible:=false;
                    end;
            end;
    end;
 procedure TfrmColocar.CrearOrdenadores();
    var i:integer;
    begin
        for i:= 0 to 23 do
            begin
                Ordenata[i]:= TImage.Create(self);
                with Ordenata[i] do
                    begin
                        width:=W_ORD_CHICO;
                        Height:=H_ORD_CHICO;
                        stretch:=true;
                        Cursor:=crhandpoint;
                        imlActivo.GetBitmap(i,Picture.Bitmap);
                        Parent:=self;
                        tag:=i;
                        left:=L_ORD_CHICO+((i mod 12)*(W_ORD_CHICO+4));
                        if i<12 then
                        top:=T_ORD_CHICO
                        else
                        top:=(T_ORD_CHICO-H_ORD_CHICO-4);
                        if i  < g_num_ord_aula then
                                visible:=true
                        else
                                visible:=false;
                        OnClick:=@OrdenataClick;
                        OnDblClick:=@OrdenataDblClick;
                        with Posiciones[i] do
                            begin
                                posI.x:=left;
                                posi.y:=top;
                                posF.x:=-1;
                                posf.y:=-1;
                                mostrado:=false;
                            end;

                    end;
                  lblOrdenata[i]:= Tlabel.Create(self);
                  with lblOrdenata[i] do
                      begin
                          autosize:=false;
                          SetBounds(Ordenata[i].Left-23,Ordenata[i].top+Ordenata[i].height,W_ORDENADOR+47,15);
                          alignment:=tacenter;
                          Font.Name:='Sans';
                          Font.Size :=10;
                          Font.Color:=rgb(100,100,100);
                          caption:= 'Mesa ' + inttostr(i+1);
                          Parent:=self;
                          font.Style:=[fsbold];
                          layout:=tlcenter;
                          Transparent:=true;
                          visible:=false;
                      end;
            end;
    end;


initialization
  {$I colocar.lrs}

end.

